#include <stdio.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#include "cb.h"
#include "widget.h"
#include "group.h"

typedef enum {
	BUTTON_CLICK,
	BUTTON_PRESS,
	COLOR_CHANGE,
	GET_SPIN,
	SET_NEW_LABEL,
	COLOR_YELLOW,
	COLOR_RED,
	COLOR_GREEN,
	SET_COLOR_YELLOW,
	SET_COLOR_GREEN,
	SET_COLOR_RED,
	ADD_LENGTH,
	ADD_LENGTH1,
	CHANGE_LENGTH,
	CHANGE_LENGTH1
} button_action;

struct _HandlerInfo {
	WPSWidget *widget;
	gchar *signal_name;
	gpointer handler;
	button_action action;
};

GHashTable *table_handler;

/*void init_table_handler()
{
	table_handler = g_hash_table_new(g_str_hash, g_str_equal);
}
*/

void add_key_to_hash(gchar *key)
{
	if (!table_handler)
		table_handler = g_hash_table_new(g_str_hash, g_str_equal);
	g_hash_table_insert(table_handler, key, NULL);
}

void add_widget_to_hash(gchar *handler_key, WPSWidget *widget)
{
	g_hash_table_insert(table_handler, handler_key, widget);
}

void handler1(GObject *object, gpointer user_data)
{
	HandlerInfo *handler_info = user_data;
	GList *last_link_attr = NULL;
	LinkAttribute *link_attr;
	gboolean value;
	WPSWidget *widget;
	WPSGroup *group;
	gdouble refresh_value;
	gdouble label_set;
	gchar res[0xff];
	GdkColor color;
	
	switch (handler_info->action) {
		case BUTTON_CLICK:
			widget = handler_info->widget;
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					value = g_value_get_boolean(link_attr->value);
					if (value == FALSE)
						g_value_set_boolean(link_attr->value, TRUE);
					else if (value == TRUE)
						g_value_set_boolean(link_attr->value, FALSE);
					else
						g_warning("Unknown boolean value\n");
				}
			}
			break;
		case BUTTON_PRESS:
			g_warning("PRESS\n");
			break;
		case COLOR_CHANGE:
			widget = handler_info->widget;
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					value = g_value_get_boolean(link_attr->value);
					if (value == FALSE)
						g_object_set(widget->goo_item, "fill-color", "red", NULL);
					else if (value == TRUE)
						g_object_set(widget->goo_item, "fill-color", "green", NULL);
					else
						g_warning("Unknown boolean value\n");
				}
			}
			break;
		case GET_SPIN:
			widget = handler_info->widget;
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					refresh_value = gtk_spin_button_get_value((GtkSpinButton *)widget->object);	
					g_value_set_double(link_attr->value, refresh_value);
				}
			}
			//g_warning("SPIN\n");
			break;
		case SET_NEW_LABEL:
			widget = handler_info->widget;
			for (last_link_attr = g_list_last(handler_info->widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					label_set = g_value_get_double(link_attr->value);
					g_ascii_dtostr(res, 0xff, label_set);
					gtk_label_set_text(widget->object, res);	
				}
			}
			//g_warning("LABEL\n");
			break;
		case SET_COLOR_YELLOW:
			widget = handler_info->widget;
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					value = g_value_get_boolean(link_attr->value);
					if (value == FALSE)
						g_value_set_boolean(link_attr->value, TRUE);
					else if (value == TRUE)
						g_value_set_boolean(link_attr->value, FALSE);
					else
						g_warning("Unknown boolean value\n");
				}
			}
			//g_warning("CLICK YELLOW\n");
			break;
		case SET_COLOR_GREEN:
			widget = handler_info->widget;
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					value = g_value_get_boolean(link_attr->value);
					if (value == FALSE)
						g_value_set_boolean(link_attr->value, TRUE);
					else if (value == TRUE)
						g_value_set_boolean(link_attr->value, FALSE);
					else
						g_warning("Unknown boolean value\n");
				}
			}
			//g_warning("CLICK GREEN\n");
			break;
		case SET_COLOR_RED:
			widget = handler_info->widget;
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					value = g_value_get_boolean(link_attr->value);
					if (value == FALSE)
						g_value_set_boolean(link_attr->value, TRUE);
					else if (value == TRUE)
						g_value_set_boolean(link_attr->value, FALSE);
					else
						g_warning("Unknown boolean value\n");
				}
			}
			//g_warning("CLICK RED\n");
			break;
		case COLOR_YELLOW:
			group = (WPSGroup *)handler_info->widget;
			for (last_link_attr = g_list_last(group->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					value = g_value_get_boolean(link_attr->value);
					if (value == FALSE)
						g_object_set(group->goo_item, "fill-color-rgba", 0xd9ec0000, "stroke-color-rgba", 0xd9ec0000, NULL);
					else if (value == TRUE)
						g_object_set(group->goo_item, "fill-color-rgba", 0xd9ec00ff,"stroke-color-rgba", 0xd9ec00ff, NULL);
					else
						g_warning("Unknown boolean value\n");
				}
			}
			//g_warning("SET YELLOW\n");
			break;
		case COLOR_GREEN:
			group = (WPSGroup *)handler_info->widget;
			for (last_link_attr = g_list_last(group->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					value = g_value_get_boolean(link_attr->value);
					if (value == FALSE)
						g_object_set(group->goo_item, "fill-color-rgba", 0x006a0000, "stroke-color-rgba", 0x006a0000, NULL);
					else if (value == TRUE)
						g_object_set(group->goo_item, "fill-color-rgba", 0x006a00ff,"stroke-color-rgba", 0x006a00ff, NULL);
					else
						g_warning("Unknown boolean value\n");
				}
			}
			//g_warning("SET GREEN\n");
			break;
		case COLOR_RED:
			group = (WPSGroup *)handler_info->widget;
			for (last_link_attr = g_list_last(group->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					value = g_value_get_boolean(link_attr->value);
					if (value == FALSE)
						g_object_set(group->goo_item, "fill-color-rgba", 0xff180000, "stroke-color-rgba", 0xff180000, NULL);
					else if (value == TRUE)
						g_object_set(group->goo_item, "fill-color-rgba", 0xff1800ff,"stroke-color-rgba", 0xff1800ff, NULL);
					else
						g_warning("Unknown boolean value\n");
				}
			}
			//g_warning("SET RED\n");
			break;
		case ADD_LENGTH:
			widget = handler_info->widget;
						
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					refresh_value = gtk_spin_button_get_value((GtkSpinButton *)widget->object);	
					g_value_set_double(link_attr->value, refresh_value);
					
					if (refresh_value > 80) {
						gdk_color_parse ("#fc0000", &color);
						gtk_widget_modify_base((GtkWidget *)widget->object, GTK_STATE_NORMAL, &color);
					}
					else if (refresh_value < 80) {
						gdk_color_parse (widget->widget_info->style_info->field_color, &color);
						gtk_widget_modify_base((GtkWidget *)widget->object, GTK_STATE_NORMAL, &color);
					}
				}
			}
			break;
		case CHANGE_LENGTH:
			widget = handler_info->widget;
			
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				gdouble spin;
					
				if (link_attr != NULL) {
					spin = g_value_get_double(link_attr->value);
					g_object_set(widget->goo_item, "height", 198.0 - spin * 198.0/100.0, NULL);
					
					
				}
			}
			break;
		case ADD_LENGTH1:
			widget = handler_info->widget;
			
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				if (link_attr != NULL) {
					refresh_value = gtk_spin_button_get_value((GtkSpinButton *)widget->object);	
					g_value_set_double(link_attr->value, refresh_value);
					
					if (refresh_value > 60) {
						gdk_color_parse ("#fc0000", &color);
						gtk_widget_modify_base((GtkWidget *)widget->object, GTK_STATE_NORMAL, &color);
					}
					else if (refresh_value < 60) {
						gdk_color_parse (widget->widget_info->style_info->field_color, &color);
						gtk_widget_modify_base((GtkWidget *)widget->object, GTK_STATE_NORMAL, &color);
					}					
				}
			}
			break;
		case CHANGE_LENGTH1:
			widget = handler_info->widget;
			
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				
				gdouble spin;
					
				if (link_attr != NULL) {
					spin = g_value_get_double(link_attr->value);
					g_object_set(widget->goo_item, "height", 198.0 - spin * 198.0/100.0, NULL);
				}
			}
			break;
		default:
			break;
	}
	
}

void assign_handlers()
{
	HandlerInfo *click_info;
	HandlerInfo *press_info;
	HandlerInfo *change_color_info;
	HandlerInfo *spin_value;
	HandlerInfo *label_info;
	HandlerInfo *click_to_yellow;
	HandlerInfo *set_to_yellow;
	WPSWidget *widget;
	WPSGroup *group;
	
	widget = g_hash_table_lookup(table_handler, "button_click");
	
	if (widget != NULL) {
		click_info = g_new0(HandlerInfo, 1);
		click_info->widget = widget;
		click_info->handler = handler1;
		click_info->action = BUTTON_CLICK;
		click_info->signal_name = g_strdup("clicked");
		
		init_handler((GObject *)widget->object, (gpointer)click_info);
	
		press_info = g_new0(HandlerInfo, 1);
		press_info->widget = widget;
		press_info->handler = handler1;
		press_info->action = BUTTON_PRESS;
		press_info->signal_name = g_strdup("pressed");
		
		init_handler((GObject *)widget->object, (gpointer)press_info);
	}
	
	widget = g_hash_table_lookup(table_handler, "get_spin_value");
	
	if (widget != NULL) {
		spin_value = g_new0(HandlerInfo, 1);
		spin_value->widget = widget;
		spin_value->handler = handler1;
		spin_value->action = GET_SPIN;
		spin_value->signal_name = g_strdup("value-changed");
		init_handler((GObject *)widget->object, (gpointer)spin_value);	
	}
	
	widget = g_hash_table_lookup(table_handler, "set_label");
	if (widget != NULL) {
		label_info = g_new0(HandlerInfo, 1);
		label_info->widget = widget;
		label_info->handler = handler1;
		label_info->action = SET_NEW_LABEL;
		label_info->signal_name = g_strdup("update_prop");
		init_handler((GObject *)widget, (gpointer)label_info);	
	}
	
	widget = g_hash_table_lookup(table_handler, "change_color");
	
	if (widget != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = widget;
		change_color_info->handler = handler1;
		change_color_info->action = COLOR_CHANGE;
		change_color_info->signal_name = g_strdup("update_prop");
		init_handler((GObject *)widget, (gpointer)change_color_info);	
	}
	
	group = g_hash_table_lookup(table_handler, "color_yellow");
	
	if (group != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = (WPSWidget*)group;
		change_color_info->handler = handler1;
		change_color_info->action = COLOR_YELLOW;
		change_color_info->signal_name = g_strdup("update_prop");
		init_handler((GObject *)group, (gpointer)change_color_info);	
	}
	
	group = g_hash_table_lookup(table_handler, "color_green");
	
	if (group != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = (WPSWidget*)group;
		change_color_info->handler = handler1;
		change_color_info->action = COLOR_GREEN;
		change_color_info->signal_name = g_strdup("update_prop");
		init_handler((GObject *)group, (gpointer)change_color_info);	
	}
	
	group = g_hash_table_lookup(table_handler, "color_red");
	
	if (group != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = (WPSWidget*)group;
		change_color_info->handler = handler1;
		change_color_info->action = COLOR_RED;
		change_color_info->signal_name = g_strdup("update_prop");
		init_handler((GObject *)group, (gpointer)change_color_info);	
	}
	
	widget = g_hash_table_lookup(table_handler, "change_to_yellow");
	
	if (widget != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = widget;
		change_color_info->handler = handler1;
		change_color_info->action = SET_COLOR_YELLOW;
		change_color_info->signal_name = g_strdup("clicked");
		init_handler((GObject *)widget->object, (gpointer)change_color_info);	
	}
	
	widget = g_hash_table_lookup(table_handler, "change_to_green");
	
	if (widget != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = widget;
		change_color_info->handler = handler1;
		change_color_info->action = SET_COLOR_GREEN;
		change_color_info->signal_name = g_strdup("clicked");
		init_handler((GObject *)widget->object, (gpointer)change_color_info);	
	}
	
	widget = g_hash_table_lookup(table_handler, "change_to_red");
	
	if (widget != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = widget;
		change_color_info->handler = handler1;
		change_color_info->action = SET_COLOR_RED;
		change_color_info->signal_name = g_strdup("clicked");
		init_handler((GObject *)widget->object, (gpointer)change_color_info);	
	}
	
	widget = g_hash_table_lookup(table_handler, "add_length");
	
	if (widget != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = widget;
		change_color_info->handler = handler1;
		change_color_info->action = ADD_LENGTH;
		change_color_info->signal_name = g_strdup("value-changed");
		init_handler((GObject *)widget->object, (gpointer)change_color_info);	
	}
	
	widget = g_hash_table_lookup(table_handler, "change_length");
	
	if (widget != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = widget;
		change_color_info->handler = handler1;
		change_color_info->action = CHANGE_LENGTH;
		change_color_info->signal_name = g_strdup("update_prop");
		init_handler((GObject *)widget, (gpointer)change_color_info);	
	}
	
	widget = g_hash_table_lookup(table_handler, "add_length1");
	
	if (widget != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = widget;
		change_color_info->handler = handler1;
		change_color_info->action = ADD_LENGTH1;
		change_color_info->signal_name = g_strdup("value-changed");
		init_handler((GObject *)widget->object, (gpointer)change_color_info);	
	}
	
	widget = g_hash_table_lookup(table_handler, "change_length1");
	
	if (widget != NULL) {
		change_color_info = g_new0(HandlerInfo, 1);
		change_color_info->widget = widget;
		change_color_info->handler = handler1;
		change_color_info->action = CHANGE_LENGTH1;
		change_color_info->signal_name = g_strdup("update_prop");
		init_handler((GObject *)widget, (gpointer)change_color_info);	
	}	
}

void init_handler(GObject *object, gpointer *h_info)
{
	
	HandlerInfo *handler_info = (HandlerInfo *)h_info;
	
	g_signal_connect(object, handler_info->signal_name, (GCallback)handler_info->handler, handler_info);
}
